//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: kava/auction/v1beta1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query defines the gRPC querier service for auction module
///
/// Usage: instantiate `Kava_Auction_V1beta1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Kava_Auction_V1beta1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Kava_Auction_V1beta1_QueryClientInterceptorFactoryProtocol? { get }

  func params(
    _ request: Kava_Auction_V1beta1_QueryParamsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Kava_Auction_V1beta1_QueryParamsRequest, Kava_Auction_V1beta1_QueryParamsResponse>

  func auction(
    _ request: Kava_Auction_V1beta1_QueryAuctionRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Kava_Auction_V1beta1_QueryAuctionRequest, Kava_Auction_V1beta1_QueryAuctionResponse>

  func auctions(
    _ request: Kava_Auction_V1beta1_QueryAuctionsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Kava_Auction_V1beta1_QueryAuctionsRequest, Kava_Auction_V1beta1_QueryAuctionsResponse>

  func nextAuctionID(
    _ request: Kava_Auction_V1beta1_QueryNextAuctionIDRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Kava_Auction_V1beta1_QueryNextAuctionIDRequest, Kava_Auction_V1beta1_QueryNextAuctionIDResponse>
}

extension Kava_Auction_V1beta1_QueryClientProtocol {
  internal var serviceName: String {
    return "kava.auction.v1beta1.Query"
  }

  /// Params queries all parameters of the auction module.
  ///
  /// - Parameters:
  ///   - request: Request to send to Params.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func params(
    _ request: Kava_Auction_V1beta1_QueryParamsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Kava_Auction_V1beta1_QueryParamsRequest, Kava_Auction_V1beta1_QueryParamsResponse> {
    return self.makeUnaryCall(
      path: "/kava.auction.v1beta1.Query/Params",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeParamsInterceptors() ?? []
    )
  }

  /// Auction queries an individual Auction by auction ID
  ///
  /// - Parameters:
  ///   - request: Request to send to Auction.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func auction(
    _ request: Kava_Auction_V1beta1_QueryAuctionRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Kava_Auction_V1beta1_QueryAuctionRequest, Kava_Auction_V1beta1_QueryAuctionResponse> {
    return self.makeUnaryCall(
      path: "/kava.auction.v1beta1.Query/Auction",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeAuctionInterceptors() ?? []
    )
  }

  /// Auctions queries auctions filtered by asset denom, owner address, phase, and auction type
  ///
  /// - Parameters:
  ///   - request: Request to send to Auctions.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func auctions(
    _ request: Kava_Auction_V1beta1_QueryAuctionsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Kava_Auction_V1beta1_QueryAuctionsRequest, Kava_Auction_V1beta1_QueryAuctionsResponse> {
    return self.makeUnaryCall(
      path: "/kava.auction.v1beta1.Query/Auctions",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeAuctionsInterceptors() ?? []
    )
  }

  /// NextAuctionID queries the next auction ID
  ///
  /// - Parameters:
  ///   - request: Request to send to NextAuctionID.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func nextAuctionID(
    _ request: Kava_Auction_V1beta1_QueryNextAuctionIDRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Kava_Auction_V1beta1_QueryNextAuctionIDRequest, Kava_Auction_V1beta1_QueryNextAuctionIDResponse> {
    return self.makeUnaryCall(
      path: "/kava.auction.v1beta1.Query/NextAuctionID",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeNextAuctionIDInterceptors() ?? []
    )
  }
}

internal protocol Kava_Auction_V1beta1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'params'.
  func makeParamsInterceptors() -> [ClientInterceptor<Kava_Auction_V1beta1_QueryParamsRequest, Kava_Auction_V1beta1_QueryParamsResponse>]

  /// - Returns: Interceptors to use when invoking 'auction'.
  func makeAuctionInterceptors() -> [ClientInterceptor<Kava_Auction_V1beta1_QueryAuctionRequest, Kava_Auction_V1beta1_QueryAuctionResponse>]

  /// - Returns: Interceptors to use when invoking 'auctions'.
  func makeAuctionsInterceptors() -> [ClientInterceptor<Kava_Auction_V1beta1_QueryAuctionsRequest, Kava_Auction_V1beta1_QueryAuctionsResponse>]

  /// - Returns: Interceptors to use when invoking 'nextAuctionID'.
  func makeNextAuctionIDInterceptors() -> [ClientInterceptor<Kava_Auction_V1beta1_QueryNextAuctionIDRequest, Kava_Auction_V1beta1_QueryNextAuctionIDResponse>]
}

internal final class Kava_Auction_V1beta1_QueryClient: Kava_Auction_V1beta1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Kava_Auction_V1beta1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the kava.auction.v1beta1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Kava_Auction_V1beta1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query defines the gRPC querier service for auction module
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Kava_Auction_V1beta1_QueryProvider: CallHandlerProvider {
  var interceptors: Kava_Auction_V1beta1_QueryServerInterceptorFactoryProtocol? { get }

  /// Params queries all parameters of the auction module.
  func params(request: Kava_Auction_V1beta1_QueryParamsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Kava_Auction_V1beta1_QueryParamsResponse>

  /// Auction queries an individual Auction by auction ID
  func auction(request: Kava_Auction_V1beta1_QueryAuctionRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Kava_Auction_V1beta1_QueryAuctionResponse>

  /// Auctions queries auctions filtered by asset denom, owner address, phase, and auction type
  func auctions(request: Kava_Auction_V1beta1_QueryAuctionsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Kava_Auction_V1beta1_QueryAuctionsResponse>

  /// NextAuctionID queries the next auction ID
  func nextAuctionID(request: Kava_Auction_V1beta1_QueryNextAuctionIDRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Kava_Auction_V1beta1_QueryNextAuctionIDResponse>
}

extension Kava_Auction_V1beta1_QueryProvider {
  internal var serviceName: Substring { return "kava.auction.v1beta1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "Params":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Kava_Auction_V1beta1_QueryParamsRequest>(),
        responseSerializer: ProtobufSerializer<Kava_Auction_V1beta1_QueryParamsResponse>(),
        interceptors: self.interceptors?.makeParamsInterceptors() ?? [],
        userFunction: self.params(request:context:)
      )

    case "Auction":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Kava_Auction_V1beta1_QueryAuctionRequest>(),
        responseSerializer: ProtobufSerializer<Kava_Auction_V1beta1_QueryAuctionResponse>(),
        interceptors: self.interceptors?.makeAuctionInterceptors() ?? [],
        userFunction: self.auction(request:context:)
      )

    case "Auctions":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Kava_Auction_V1beta1_QueryAuctionsRequest>(),
        responseSerializer: ProtobufSerializer<Kava_Auction_V1beta1_QueryAuctionsResponse>(),
        interceptors: self.interceptors?.makeAuctionsInterceptors() ?? [],
        userFunction: self.auctions(request:context:)
      )

    case "NextAuctionID":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Kava_Auction_V1beta1_QueryNextAuctionIDRequest>(),
        responseSerializer: ProtobufSerializer<Kava_Auction_V1beta1_QueryNextAuctionIDResponse>(),
        interceptors: self.interceptors?.makeNextAuctionIDInterceptors() ?? [],
        userFunction: self.nextAuctionID(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Kava_Auction_V1beta1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'params'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeParamsInterceptors() -> [ServerInterceptor<Kava_Auction_V1beta1_QueryParamsRequest, Kava_Auction_V1beta1_QueryParamsResponse>]

  /// - Returns: Interceptors to use when handling 'auction'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeAuctionInterceptors() -> [ServerInterceptor<Kava_Auction_V1beta1_QueryAuctionRequest, Kava_Auction_V1beta1_QueryAuctionResponse>]

  /// - Returns: Interceptors to use when handling 'auctions'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeAuctionsInterceptors() -> [ServerInterceptor<Kava_Auction_V1beta1_QueryAuctionsRequest, Kava_Auction_V1beta1_QueryAuctionsResponse>]

  /// - Returns: Interceptors to use when handling 'nextAuctionID'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeNextAuctionIDInterceptors() -> [ServerInterceptor<Kava_Auction_V1beta1_QueryNextAuctionIDRequest, Kava_Auction_V1beta1_QueryNextAuctionIDResponse>]
}
